<?php

namespace Drupal\more_fields_video\Form;

use Drupal\Core\Entity\ContentEntityForm;
use Drupal\Core\Form\FormStateInterface;

/**
 * Form controller for the multiformat video entity edit forms.
 */
class MultiformatVideoForm extends ContentEntityForm {

  /**
   * {@inheritdoc}
   */
  public function save(array $form, FormStateInterface $form_state) {
    $result = parent::save($form, $form_state);

    $entity = $this->getEntity();

    $message_arguments = ['%label' => $entity->toLink()->toString()];
    $logger_arguments = [
      '%label' => $entity->label(),
      'link' => $entity->toLink($this->t('View'))->toString(),
    ];

    switch ($result) {
      case SAVED_NEW:
        $this->messenger()->addStatus($this->t('New multiformat video %label has been created.', $message_arguments));
        $this->logger('more_fields_video')->notice('Created new multiformat video %label', $logger_arguments);
        break;

      case SAVED_UPDATED:
        $this->messenger()->addStatus($this->t('The multiformat video %label has been updated.', $message_arguments));
        $this->logger('more_fields_video')->notice('Updated multiformat video %label.', $logger_arguments);
        break;
    }

    $form_state->setRedirect('entity.multiformat_video.collection');

    return $result;
  }

}
